// --------------------------------------------------------------------------------------
//
// PerDaten.CS                                                     Ulrich Mller 23.11.05
//                                                                 PCS1700       C# Final
// ftTeachCS : Klassen fr Persistente Daten
// Binre Serialisation, Einzeldaten, Tabelle. 
// Konstruktor mit Vorbelegung fr ein neues File
//
// --------------------------------------------------------------------------------------

using System;

namespace ftTeachCS
{
	[Serializable()]public struct RobSatz {
		public string Name;
		public int    rNr;
		public string Typ;
		public int    tNr;
		public string Text;
		public int    Saule;
		public int    ArmH;
		public int    ArmV;
		public int    Greifer;
	}

	[Serializable()]public struct IntSatz {
		public string  Name;
		public int     iNr;
		public int     Typ;
		public bool    COM;
		public string  Port;
		public int     pNr;
		public int     Serial;
		public string  Firmware;
	}

	[Serializable()]public class PerDaten {
		public int    FormLeft;
		public int    FormTop;
		public int    AnzRob;
		public int    AnzInt;

		public RobSatz[] RobModelle = new RobSatz[10];  // --- Index 0 : akt. Modell
		public IntSatz[] IntModelle = new IntSatz[10];  // --- Index 0 : akt. Interface

		// --- Konstruktor ---------------------
		public PerDaten() {
			// --- Initialisierung fr das erste Mal, wenn noch kein Datenfile existiert
			FormLeft  = 0;
			FormTop   = 0;
			AnzRob    = RobModelle.Length;
			for (int i = 0; i < AnzRob; i++) {
				RobModelle[i].Name    = "Rob0";
				RobModelle[i].rNr     = i;
				RobModelle[i].Typ     = "Greifer";
				RobModelle[i].tNr     = 0;
				RobModelle[i].Text    = "Standard Sulen-Roboter";
				RobModelle[i].Saule   = 225;
				RobModelle[i].ArmH    = 160;
				RobModelle[i].ArmV    = 150;
				RobModelle[i].Greifer = 26;
			} 
			AnzInt = IntModelle.Length;
			IntModelle[0].Name     = "ROBO first USB";
			IntModelle[0].iNr      = 0;
			IntModelle[0].Typ      = 0;
			IntModelle[0].COM      = false;
			IntModelle[0].Port     = "USB";
			IntModelle[0].pNr      = 0;
			IntModelle[0].Serial   = 0;
			IntModelle[0].Firmware = "v0.0.0.0";
			IntModelle[1].Name     = "ROBO first USB";
			IntModelle[1].iNr      = 1;
			IntModelle[1].Typ      = 0;
			IntModelle[1].COM      = false;
			IntModelle[1].Port     = "USB";
			IntModelle[1].pNr      = 1;
			IntModelle[1].Serial   = 0;
			IntModelle[1].Firmware = "v0.0.0.0";
			IntModelle[2].Name     = "Intelligent IF";
			IntModelle[2].iNr      = 2;
			IntModelle[2].Typ      = 10;
			IntModelle[2].COM      = true;
			IntModelle[2].Port     = "COM1";
			IntModelle[2].pNr      = 2;
			IntModelle[2].Serial   = 0;
			IntModelle[2].Firmware = "v0.0.0.0";
			IntModelle[3].Name     = "Intelligent IF Slave";
			IntModelle[3].iNr      = 3;
			IntModelle[3].Typ      = 20;
			IntModelle[3].COM      = true;
			IntModelle[3].Port     = "COM1";
			IntModelle[3].pNr      = 2;
			IntModelle[3].Serial   = 0;
			IntModelle[3].Firmware = "v0.0.0.0";
			IntModelle[4].Name     = "ROBO IF IIM";
			IntModelle[4].iNr      = 4;
			IntModelle[4].Typ      = 50;
			IntModelle[4].COM      = true;
			IntModelle[4].Port     = "COM1";
			IntModelle[4].pNr      = 2;
			IntModelle[4].Serial   = 0;
			IntModelle[4].Firmware = "v0.0.0.0";
			IntModelle[5].Name     = "ROBO IF USB";
			IntModelle[5].iNr      = 5;
			IntModelle[5].Typ      = 60;
			IntModelle[5].COM      = false;
			IntModelle[5].Port     = "USB";
			IntModelle[5].pNr      = 1;
			IntModelle[5].Serial   = 1;
			IntModelle[5].Firmware = "v0.0.0.0";
			IntModelle[6].Name     = "ROBO IF COM";
			IntModelle[6].iNr      = 6;
			IntModelle[6].Typ      = 70;
			IntModelle[6].COM      = true;
			IntModelle[6].Port     = "COM1";
			IntModelle[6].pNr      = 2;
			IntModelle[6].Serial   = 0;
			IntModelle[6].Firmware = "v0.0.0.0";
			IntModelle[7].Name     = "ROBO IF Over RF";
			IntModelle[7].iNr      = 7;
			IntModelle[7].Typ      = 80;
			IntModelle[7].COM      = false;
			IntModelle[7].Port     = "USB";
			IntModelle[7].pNr      = 1;
			IntModelle[7].Serial   = 1;
			IntModelle[7].Firmware = "v0.0.0.0";
			IntModelle[8].Name     = "ROBO IO Extension";
			IntModelle[8].iNr      = 8;
			IntModelle[8].Typ      = 90;
			IntModelle[8].COM      = false;
			IntModelle[8].Port     = "USB";
			IntModelle[8].pNr      = 1;
			IntModelle[8].Serial   = 1;
			IntModelle[8].Firmware = "v0.0.0.0";
			IntModelle[9].Name     = "ROBO RF Datalink";
			IntModelle[9].iNr      = 9;
			IntModelle[9].Typ      = 110;
			IntModelle[9].COM      = false;
			IntModelle[9].Port     = "USB";
			IntModelle[9].pNr      = 1;
			IntModelle[9].Serial   = 1;
			IntModelle[9].Firmware = "v0.0.0.0";
		}

		// --- Zugriff auf die RobModell-Liste ber Indexer --------------
		public RobSatz this[int i] {
			get {return RobModelle[i];}
			set {RobModelle[i] = value;}
		}
	}
}
