// -------------------------------------------------------------------------------------
// 
// TeachMain.CS                                                   Ulrich Mller 22.11.05
//                                                                PCS1700   C# Final SP2
// TeachIn Programm fr die Industry Robots
//
// Interne Nutzung eines internen FishFace40.CS (umFish40.DLL normal)
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using FishFace40;

namespace ftTeachCS
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label          lblTitel;
		private System.Windows.Forms.Timer          tmrI;

		private System.Windows.Forms.MainMenu       mnuMain;
		private System.Windows.Forms.MenuItem       mnuDatei;
		private System.Windows.Forms.MenuItem       mnuNeu;
		private System.Windows.Forms.MenuItem       mnuOffnen;
		private System.Windows.Forms.MenuItem       mnuSpeichern;
		private System.Windows.Forms.MenuItem       mnuSpeichernU;
		private System.Windows.Forms.MenuItem       mnuBeenden;
		private System.Windows.Forms.MenuItem       mnuExtras;
		private System.Windows.Forms.MenuItem       mnuInterface;
		private System.Windows.Forms.MenuItem       mnuModell;
		private System.Windows.Forms.MenuItem       mnuAbout;
		private System.Windows.Forms.MenuItem       menuItem4;

		private System.Windows.Forms.ListBox        lstScript;
		private System.Windows.Forms.ListBox        lstDaten;
		private System.Windows.Forms.Button         cmdAction;
		private System.Windows.Forms.Button         cmdEnde;
		private System.Windows.Forms.Label          lblStatus;
		private System.Windows.Forms.Label          lblBetrieb;
		private System.Windows.Forms.Label          label1;

		private System.Windows.Forms.PictureBox     picDrive;
		private System.Windows.Forms.Label          lblSaule;
		private System.Windows.Forms.Label          lblSauleLinks;
		private System.Windows.Forms.Label          lblSauleRechts;
		private System.Windows.Forms.Label          lblSaulePos;
		private System.Windows.Forms.Label          lblArmV;
		private System.Windows.Forms.Label          lblArmVPos;
		private System.Windows.Forms.Label          lblArmVHoch;
		private System.Windows.Forms.Label          lblArmVAb;
		private System.Windows.Forms.Label          lblArmH;
		private System.Windows.Forms.Label          lblArmHPos;
		private System.Windows.Forms.Label          lblArmHVor;
		private System.Windows.Forms.Label          lblArmHRuck;
		private System.Windows.Forms.Label          lblGreifer;
		private System.Windows.Forms.Label          lblGreiferZu;
		private System.Windows.Forms.Label          lblGreiferAuf;

		private System.Windows.Forms.Panel          pnlScript;
		private System.Windows.Forms.Button         cmdPosSpeichern;
		private System.Windows.Forms.Button         cmdPosEinfugen;
		private System.Windows.Forms.Button         cmbPosAnfugen;
		private System.Windows.Forms.Button         cmdPosLoschen;

		private System.Windows.Forms.Panel          pnlRun;
		private System.Windows.Forms.Button         cmdRunStart;
		private System.Windows.Forms.Button         cmdRunTo;
		private System.Windows.Forms.Button         cmdRunBack;
		private System.Windows.Forms.Button         cmdRunForward;
		private System.Windows.Forms.CheckBox       chkRunRepeat;

		private System.Windows.Forms.OpenFileDialog openScript;
		private System.Windows.Forms.SaveFileDialog saveScript;
		private System.ComponentModel.IContainer components;

		// --- Programm-Zustnde -----------------------------
		private enum PrgModus {None, Ein, Home, TeachIn, Run};

		private PerDaten pd;                        // --- Persistente Daten
		private RobSatz Modell    = new RobSatz();  // --- aktuelle Robot-Daten
		private IntSatz Interface = new IntSatz();  // --- aktuelle Interface-Daten
		private string IniName                      // --- Pfadname der PerDaten
			= new DirectoryInfo(".\\").FullName + "ftTeachCS.BIN";
		private PrgModus prgModus = PrgModus.None;  // --- aktueller PrgModus
		private FishRobot ft;                       // --- Interface-Instanz
		private string ScriptName = "";             // --- Pfadname des akt. Scriptfiles
		private bool IsDirty;                       // --- akt. Scriptfile wurde gendert
		private int[] MoveWerte = new int[4];       // --- akt. (Soll)Position

		public frmMain()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.lblTitel = new System.Windows.Forms.Label();
			this.mnuMain = new System.Windows.Forms.MainMenu();
			this.mnuDatei = new System.Windows.Forms.MenuItem();
			this.mnuNeu = new System.Windows.Forms.MenuItem();
			this.mnuOffnen = new System.Windows.Forms.MenuItem();
			this.mnuSpeichern = new System.Windows.Forms.MenuItem();
			this.mnuSpeichernU = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.mnuBeenden = new System.Windows.Forms.MenuItem();
			this.mnuExtras = new System.Windows.Forms.MenuItem();
			this.mnuInterface = new System.Windows.Forms.MenuItem();
			this.mnuModell = new System.Windows.Forms.MenuItem();
			this.mnuAbout = new System.Windows.Forms.MenuItem();
			this.pnlScript = new System.Windows.Forms.Panel();
			this.cmdPosLoschen = new System.Windows.Forms.Button();
			this.cmbPosAnfugen = new System.Windows.Forms.Button();
			this.cmdPosEinfugen = new System.Windows.Forms.Button();
			this.cmdPosSpeichern = new System.Windows.Forms.Button();
			this.pnlRun = new System.Windows.Forms.Panel();
			this.chkRunRepeat = new System.Windows.Forms.CheckBox();
			this.cmdRunForward = new System.Windows.Forms.Button();
			this.cmdRunBack = new System.Windows.Forms.Button();
			this.cmdRunTo = new System.Windows.Forms.Button();
			this.cmdRunStart = new System.Windows.Forms.Button();
			this.lstScript = new System.Windows.Forms.ListBox();
			this.lstDaten = new System.Windows.Forms.ListBox();
			this.picDrive = new System.Windows.Forms.PictureBox();
			this.cmdAction = new System.Windows.Forms.Button();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.lblBetrieb = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.tmrI = new System.Windows.Forms.Timer(this.components);
			this.lblSaule = new System.Windows.Forms.Label();
			this.lblArmV = new System.Windows.Forms.Label();
			this.lblArmH = new System.Windows.Forms.Label();
			this.lblGreifer = new System.Windows.Forms.Label();
			this.lblGreiferZu = new System.Windows.Forms.Label();
			this.lblSauleLinks = new System.Windows.Forms.Label();
			this.lblSauleRechts = new System.Windows.Forms.Label();
			this.lblArmHVor = new System.Windows.Forms.Label();
			this.lblArmHRuck = new System.Windows.Forms.Label();
			this.lblArmVHoch = new System.Windows.Forms.Label();
			this.lblArmVAb = new System.Windows.Forms.Label();
			this.lblGreiferAuf = new System.Windows.Forms.Label();
			this.lblArmVPos = new System.Windows.Forms.Label();
			this.lblSaulePos = new System.Windows.Forms.Label();
			this.lblArmHPos = new System.Windows.Forms.Label();
			this.openScript = new System.Windows.Forms.OpenFileDialog();
			this.saveScript = new System.Windows.Forms.SaveFileDialog();
			this.pnlScript.SuspendLayout();
			this.pnlRun.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblTitel
			// 
			this.lblTitel.BackColor = System.Drawing.Color.Gainsboro;
			this.lblTitel.Font = new System.Drawing.Font("Verdana", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTitel.Location = new System.Drawing.Point(24, 24);
			this.lblTitel.Name = "lblTitel";
			this.lblTitel.Size = new System.Drawing.Size(640, 32);
			this.lblTitel.TabIndex = 0;
			this.lblTitel.Text = "Titel";
			this.lblTitel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// mnuMain
			// 
			this.mnuMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuDatei,
																					this.mnuExtras,
																					this.mnuAbout});
			// 
			// mnuDatei
			// 
			this.mnuDatei.Index = 0;
			this.mnuDatei.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.mnuNeu,
																					 this.mnuOffnen,
																					 this.mnuSpeichern,
																					 this.mnuSpeichernU,
																					 this.menuItem4,
																					 this.mnuBeenden});
			this.mnuDatei.Text = "Datei";
			// 
			// mnuNeu
			// 
			this.mnuNeu.Index = 0;
			this.mnuNeu.Text = "Neu";
			this.mnuNeu.Click += new System.EventHandler(this.mnuNeu_Click);
			// 
			// mnuOffnen
			// 
			this.mnuOffnen.Index = 1;
			this.mnuOffnen.Text = "ffnen";
			this.mnuOffnen.Click += new System.EventHandler(this.mnuOffnen_Click);
			// 
			// mnuSpeichern
			// 
			this.mnuSpeichern.Index = 2;
			this.mnuSpeichern.Text = "Speichern";
			this.mnuSpeichern.Click += new System.EventHandler(this.mnuSpeichern_Click);
			// 
			// mnuSpeichernU
			// 
			this.mnuSpeichernU.Index = 3;
			this.mnuSpeichernU.Text = "Speichern unter...";
			this.mnuSpeichernU.Click += new System.EventHandler(this.mnuSpeichernU_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 4;
			this.menuItem4.Text = "--";
			// 
			// mnuBeenden
			// 
			this.mnuBeenden.Index = 5;
			this.mnuBeenden.Text = "Beenden";
			this.mnuBeenden.Click += new System.EventHandler(this.mnuBeenden_Click);
			// 
			// mnuExtras
			// 
			this.mnuExtras.Index = 1;
			this.mnuExtras.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuInterface,
																					  this.mnuModell});
			this.mnuExtras.Text = "Extras";
			// 
			// mnuInterface
			// 
			this.mnuInterface.Index = 0;
			this.mnuInterface.Text = "Inteface...";
			this.mnuInterface.Click += new System.EventHandler(this.mnuInterface_Click);
			// 
			// mnuModell
			// 
			this.mnuModell.Index = 1;
			this.mnuModell.Text = "Modell...";
			this.mnuModell.Click += new System.EventHandler(this.mnuModell_Click);
			// 
			// mnuAbout
			// 
			this.mnuAbout.Index = 2;
			this.mnuAbout.Text = "About";
			this.mnuAbout.Click += new System.EventHandler(this.mnuAbout_Click);
			// 
			// pnlScript
			// 
			this.pnlScript.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlScript.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.cmdPosLoschen,
																					this.cmbPosAnfugen,
																					this.cmdPosEinfugen,
																					this.cmdPosSpeichern});
			this.pnlScript.Location = new System.Drawing.Point(320, 72);
			this.pnlScript.Name = "pnlScript";
			this.pnlScript.Size = new System.Drawing.Size(160, 160);
			this.pnlScript.TabIndex = 1;
			// 
			// cmdPosLoschen
			// 
			this.cmdPosLoschen.Location = new System.Drawing.Point(8, 118);
			this.cmdPosLoschen.Name = "cmdPosLoschen";
			this.cmdPosLoschen.Size = new System.Drawing.Size(144, 24);
			this.cmdPosLoschen.TabIndex = 3;
			this.cmdPosLoschen.Text = "Position Lschen";
			this.cmdPosLoschen.Click += new System.EventHandler(this.cmdPosLoschen_Click);
			// 
			// cmbPosAnfugen
			// 
			this.cmbPosAnfugen.Location = new System.Drawing.Point(8, 84);
			this.cmbPosAnfugen.Name = "cmbPosAnfugen";
			this.cmbPosAnfugen.Size = new System.Drawing.Size(144, 24);
			this.cmbPosAnfugen.TabIndex = 2;
			this.cmbPosAnfugen.Text = "Posistion Anfgen";
			this.cmbPosAnfugen.Click += new System.EventHandler(this.cmbPosAnfugen_Click);
			// 
			// cmdPosEinfugen
			// 
			this.cmdPosEinfugen.Location = new System.Drawing.Point(8, 50);
			this.cmdPosEinfugen.Name = "cmdPosEinfugen";
			this.cmdPosEinfugen.Size = new System.Drawing.Size(144, 24);
			this.cmdPosEinfugen.TabIndex = 1;
			this.cmdPosEinfugen.Text = "Position Einfgen";
			this.cmdPosEinfugen.Click += new System.EventHandler(this.cmdPosEinfugen_Click);
			// 
			// cmdPosSpeichern
			// 
			this.cmdPosSpeichern.Location = new System.Drawing.Point(8, 16);
			this.cmdPosSpeichern.Name = "cmdPosSpeichern";
			this.cmdPosSpeichern.Size = new System.Drawing.Size(144, 24);
			this.cmdPosSpeichern.TabIndex = 0;
			this.cmdPosSpeichern.Text = "Position Speichern";
			this.cmdPosSpeichern.Click += new System.EventHandler(this.cmdPosSpeichern_Click);
			// 
			// pnlRun
			// 
			this.pnlRun.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlRun.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.chkRunRepeat,
																				 this.cmdRunForward,
																				 this.cmdRunBack,
																				 this.cmdRunTo,
																				 this.cmdRunStart});
			this.pnlRun.Location = new System.Drawing.Point(496, 72);
			this.pnlRun.Name = "pnlRun";
			this.pnlRun.Size = new System.Drawing.Size(160, 160);
			this.pnlRun.TabIndex = 2;
			// 
			// chkRunRepeat
			// 
			this.chkRunRepeat.Location = new System.Drawing.Point(16, 56);
			this.chkRunRepeat.Name = "chkRunRepeat";
			this.chkRunRepeat.Size = new System.Drawing.Size(136, 16);
			this.chkRunRepeat.TabIndex = 4;
			this.chkRunRepeat.Text = "Script Wiederholen";
			// 
			// cmdRunForward
			// 
			this.cmdRunForward.Location = new System.Drawing.Point(96, 88);
			this.cmdRunForward.Name = "cmdRunForward";
			this.cmdRunForward.Size = new System.Drawing.Size(53, 24);
			this.cmdRunForward.TabIndex = 3;
			this.cmdRunForward.Tag = "2";
			this.cmdRunForward.Text = ">";
			this.cmdRunForward.Click += new System.EventHandler(this.cmdRunClick);
			// 
			// cmdRunBack
			// 
			this.cmdRunBack.Location = new System.Drawing.Point(8, 88);
			this.cmdRunBack.Name = "cmdRunBack";
			this.cmdRunBack.Size = new System.Drawing.Size(53, 24);
			this.cmdRunBack.TabIndex = 2;
			this.cmdRunBack.Tag = "1";
			this.cmdRunBack.Text = "<";
			this.cmdRunBack.Click += new System.EventHandler(this.cmdRunClick);
			// 
			// cmdRunTo
			// 
			this.cmdRunTo.Location = new System.Drawing.Point(8, 120);
			this.cmdRunTo.Name = "cmdRunTo";
			this.cmdRunTo.Size = new System.Drawing.Size(144, 24);
			this.cmdRunTo.TabIndex = 1;
			this.cmdRunTo.Tag = "3";
			this.cmdRunTo.Text = "Position Anfahren";
			this.cmdRunTo.Click += new System.EventHandler(this.cmdRunClick);
			// 
			// cmdRunStart
			// 
			this.cmdRunStart.Location = new System.Drawing.Point(8, 16);
			this.cmdRunStart.Name = "cmdRunStart";
			this.cmdRunStart.Size = new System.Drawing.Size(144, 24);
			this.cmdRunStart.TabIndex = 0;
			this.cmdRunStart.Text = "Script Starten";
			this.cmdRunStart.Click += new System.EventHandler(this.cmdRunStart_Click);
			// 
			// lstScript
			// 
			this.lstScript.BackColor = System.Drawing.Color.Gainsboro;
			this.lstScript.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lstScript.ItemHeight = 16;
			this.lstScript.Location = new System.Drawing.Point(24, 72);
			this.lstScript.Name = "lstScript";
			this.lstScript.Size = new System.Drawing.Size(280, 148);
			this.lstScript.TabIndex = 3;
			// 
			// lstDaten
			// 
			this.lstDaten.BackColor = System.Drawing.Color.Gainsboro;
			this.lstDaten.Location = new System.Drawing.Point(24, 248);
			this.lstDaten.Name = "lstDaten";
			this.lstDaten.Size = new System.Drawing.Size(112, 251);
			this.lstDaten.TabIndex = 4;
			// 
			// picDrive
			// 
			this.picDrive.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.picDrive.Location = new System.Drawing.Point(160, 248);
			this.picDrive.Name = "picDrive";
			this.picDrive.Size = new System.Drawing.Size(320, 248);
			this.picDrive.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.picDrive.TabIndex = 5;
			this.picDrive.TabStop = false;
			// 
			// cmdAction
			// 
			this.cmdAction.Font = new System.Drawing.Font("Verdana", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdAction.Location = new System.Drawing.Point(512, 464);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(144, 32);
			this.cmdAction.TabIndex = 6;
			this.cmdAction.Text = "EIN";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// cmdEnde
			// 
			this.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdEnde.Font = new System.Drawing.Font("Verdana", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdEnde.Location = new System.Drawing.Point(512, 424);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(144, 32);
			this.cmdEnde.TabIndex = 7;
			this.cmdEnde.Text = "Abbrechen";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.Font = new System.Drawing.Font("Verdana", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(504, 368);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(160, 40);
			this.lblStatus.TabIndex = 8;
			this.lblStatus.Text = "Status";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblBetrieb
			// 
			this.lblBetrieb.BackColor = System.Drawing.SystemColors.ControlDark;
			this.lblBetrieb.Location = new System.Drawing.Point(504, 312);
			this.lblBetrieb.Name = "lblBetrieb";
			this.lblBetrieb.Size = new System.Drawing.Size(24, 24);
			this.lblBetrieb.TabIndex = 9;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(544, 320);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 12);
			this.label1.TabIndex = 10;
			this.label1.Text = "Interface-Status";
			// 
			// tmrI
			// 
			this.tmrI.Tick += new System.EventHandler(this.tmrI_Tick);
			// 
			// lblSaule
			// 
			this.lblSaule.BackColor = System.Drawing.Color.Gray;
			this.lblSaule.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblSaule.Location = new System.Drawing.Point(240, 416);
			this.lblSaule.Name = "lblSaule";
			this.lblSaule.Size = new System.Drawing.Size(176, 48);
			this.lblSaule.TabIndex = 11;
			// 
			// lblArmV
			// 
			this.lblArmV.BackColor = System.Drawing.Color.Gray;
			this.lblArmV.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblArmV.Location = new System.Drawing.Point(312, 312);
			this.lblArmV.Name = "lblArmV";
			this.lblArmV.Size = new System.Drawing.Size(32, 120);
			this.lblArmV.TabIndex = 12;
			// 
			// lblArmH
			// 
			this.lblArmH.BackColor = System.Drawing.Color.Gray;
			this.lblArmH.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblArmH.Location = new System.Drawing.Point(240, 296);
			this.lblArmH.Name = "lblArmH";
			this.lblArmH.Size = new System.Drawing.Size(168, 32);
			this.lblArmH.TabIndex = 13;
			// 
			// lblGreifer
			// 
			this.lblGreifer.BackColor = System.Drawing.Color.Gray;
			this.lblGreifer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblGreifer.Location = new System.Drawing.Point(224, 280);
			this.lblGreifer.Name = "lblGreifer";
			this.lblGreifer.Size = new System.Drawing.Size(16, 64);
			this.lblGreifer.TabIndex = 14;
			// 
			// lblGreiferZu
			// 
			this.lblGreiferZu.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(192)), ((System.Byte)(0)));
			this.lblGreiferZu.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblGreiferZu.Location = new System.Drawing.Point(224, 328);
			this.lblGreiferZu.Name = "lblGreiferZu";
			this.lblGreiferZu.Size = new System.Drawing.Size(16, 16);
			this.lblGreiferZu.TabIndex = 15;
			this.lblGreiferZu.Tag = "8";
			this.lblGreiferZu.Text = "-";
			this.lblGreiferZu.Click += new System.EventHandler(this.lblGreiferClick);
			this.lblGreiferZu.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseDown);
			// 
			// lblSauleLinks
			// 
			this.lblSauleLinks.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(192)), ((System.Byte)(0)));
			this.lblSauleLinks.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblSauleLinks.Location = new System.Drawing.Point(256, 432);
			this.lblSauleLinks.Name = "lblSauleLinks";
			this.lblSauleLinks.Size = new System.Drawing.Size(16, 16);
			this.lblSauleLinks.TabIndex = 16;
			this.lblSauleLinks.Tag = "1";
			this.lblSauleLinks.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseUp);
			this.lblSauleLinks.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseDown);
			// 
			// lblSauleRechts
			// 
			this.lblSauleRechts.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(192)), ((System.Byte)(0)));
			this.lblSauleRechts.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblSauleRechts.Location = new System.Drawing.Point(384, 432);
			this.lblSauleRechts.Name = "lblSauleRechts";
			this.lblSauleRechts.Size = new System.Drawing.Size(16, 16);
			this.lblSauleRechts.TabIndex = 17;
			this.lblSauleRechts.Tag = "2";
			this.lblSauleRechts.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseUp);
			this.lblSauleRechts.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseDown);
			// 
			// lblArmHVor
			// 
			this.lblArmHVor.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(192)), ((System.Byte)(0)));
			this.lblArmHVor.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblArmHVor.Location = new System.Drawing.Point(248, 304);
			this.lblArmHVor.Name = "lblArmHVor";
			this.lblArmHVor.Size = new System.Drawing.Size(16, 16);
			this.lblArmHVor.TabIndex = 18;
			this.lblArmHVor.Tag = "4";
			this.lblArmHVor.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseUp);
			this.lblArmHVor.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseDown);
			// 
			// lblArmHRuck
			// 
			this.lblArmHRuck.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(192)), ((System.Byte)(0)));
			this.lblArmHRuck.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblArmHRuck.Location = new System.Drawing.Point(384, 304);
			this.lblArmHRuck.Name = "lblArmHRuck";
			this.lblArmHRuck.Size = new System.Drawing.Size(16, 16);
			this.lblArmHRuck.TabIndex = 19;
			this.lblArmHRuck.Tag = "3";
			this.lblArmHRuck.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseUp);
			this.lblArmHRuck.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseDown);
			// 
			// lblArmVHoch
			// 
			this.lblArmVHoch.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(192)), ((System.Byte)(0)));
			this.lblArmVHoch.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblArmVHoch.Location = new System.Drawing.Point(320, 336);
			this.lblArmVHoch.Name = "lblArmVHoch";
			this.lblArmVHoch.Size = new System.Drawing.Size(16, 16);
			this.lblArmVHoch.TabIndex = 20;
			this.lblArmVHoch.Tag = "5";
			this.lblArmVHoch.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseUp);
			this.lblArmVHoch.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseDown);
			// 
			// lblArmVAb
			// 
			this.lblArmVAb.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(192)), ((System.Byte)(0)));
			this.lblArmVAb.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblArmVAb.Location = new System.Drawing.Point(320, 408);
			this.lblArmVAb.Name = "lblArmVAb";
			this.lblArmVAb.Size = new System.Drawing.Size(16, 16);
			this.lblArmVAb.TabIndex = 21;
			this.lblArmVAb.Tag = "6";
			this.lblArmVAb.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseUp);
			this.lblArmVAb.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseDown);
			// 
			// lblGreiferAuf
			// 
			this.lblGreiferAuf.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(192)), ((System.Byte)(0)));
			this.lblGreiferAuf.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblGreiferAuf.Location = new System.Drawing.Point(224, 280);
			this.lblGreiferAuf.Name = "lblGreiferAuf";
			this.lblGreiferAuf.Size = new System.Drawing.Size(16, 16);
			this.lblGreiferAuf.TabIndex = 22;
			this.lblGreiferAuf.Tag = "7";
			this.lblGreiferAuf.Text = "+";
			this.lblGreiferAuf.Click += new System.EventHandler(this.lblGreiferClick);
			this.lblGreiferAuf.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblRobMouseDown);
			// 
			// lblArmVPos
			// 
			this.lblArmVPos.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.lblArmVPos.Location = new System.Drawing.Point(312, 368);
			this.lblArmVPos.Name = "lblArmVPos";
			this.lblArmVPos.Size = new System.Drawing.Size(32, 16);
			this.lblArmVPos.TabIndex = 23;
			this.lblArmVPos.Text = "0";
			this.lblArmVPos.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblSaulePos
			// 
			this.lblSaulePos.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.lblSaulePos.Location = new System.Drawing.Point(312, 440);
			this.lblSaulePos.Name = "lblSaulePos";
			this.lblSaulePos.Size = new System.Drawing.Size(32, 16);
			this.lblSaulePos.TabIndex = 24;
			this.lblSaulePos.Text = "0";
			this.lblSaulePos.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblArmHPos
			// 
			this.lblArmHPos.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.lblArmHPos.Location = new System.Drawing.Point(312, 304);
			this.lblArmHPos.Name = "lblArmHPos";
			this.lblArmHPos.Size = new System.Drawing.Size(32, 16);
			this.lblArmHPos.TabIndex = 25;
			this.lblArmHPos.Text = "0";
			this.lblArmHPos.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// openScript
			// 
			this.openScript.DefaultExt = "RB5";
			this.openScript.Filter = "Script-Files|*.RB*|Alle Files|*.*";
			this.openScript.Title = "ftTeachCS";
			// 
			// saveScript
			// 
			this.saveScript.Filter = "Script-Files|*.RB*|Alle Files|*.*";
			this.saveScript.Title = "ftTeachCS";
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.CancelButton = this.cmdEnde;
			this.ClientSize = new System.Drawing.Size(686, 519);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblArmHPos,
																		  this.lblArmVPos,
																		  this.lblSaulePos,
																		  this.lblGreiferAuf,
																		  this.lblArmVAb,
																		  this.lblArmVHoch,
																		  this.lblArmHRuck,
																		  this.lblArmHVor,
																		  this.lblSauleRechts,
																		  this.lblSauleLinks,
																		  this.lblGreiferZu,
																		  this.lblGreifer,
																		  this.lblArmH,
																		  this.lblArmV,
																		  this.lblSaule,
																		  this.label1,
																		  this.lblBetrieb,
																		  this.lblStatus,
																		  this.cmdEnde,
																		  this.cmdAction,
																		  this.picDrive,
																		  this.lstDaten,
																		  this.lstScript,
																		  this.pnlRun,
																		  this.pnlScript,
																		  this.lblTitel});
			this.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Menu = this.mnuMain;
			this.Name = "frmMain";
			this.Text = "ftTeachCS";
			this.Load += new System.EventHandler(this.frmMain_Load);
			this.Closed += new System.EventHandler(this.frmMain_Closed);
			this.pnlScript.ResumeLayout(false);
			this.pnlRun.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		
		// --- Hilfsprogramme ---------------------------------------------

		private void ModellDaten() {  // --- Anzeige akt. Modell- und Interface-Daten
			lblTitel.Text  = Modell.Text;
			lstDaten.Items.Clear();
			lstDaten.Items.Add("Modell : " + Modell.Name);
			lstDaten.Items.Add("mit : " + Modell.Typ);
			lstDaten.Items.Add("");
			lstDaten.Items.Add("Arbeitsraum");
			lstDaten.Items.Add("Sule : " + Modell.Saule.ToString());
			lstDaten.Items.Add("ArmH : " + Modell.ArmH.ToString());
			lstDaten.Items.Add("ArmV : " + Modell.ArmV.ToString());
			if(Modell.tNr  == 0) 
				lstDaten.Items.Add("Greifer : " + Modell.Greifer.ToString());
			lstDaten.Items.Add("");
			lstDaten.Items.Add("Interface");
			lstDaten.Items.Add(Interface.Name);
			lstDaten.Items.Add(Interface.Port);
			if(!Interface.COM) {
				lstDaten.Items.Add("SerialNr : " + Interface.Serial);
				lstDaten.Items.Add("Firmware Version");
				lstDaten.Items.Add(Interface.Firmware);
			}
		}

		private void ModusWechsel (PrgModus newModus) {  // --- Eigenschaftsnderungen
			                                             //     beim PrgModus-Wechsel
			switch (newModus) {
				case PrgModus.Ein:
					lblStatus.Text      = "EINschalten";
					lblStatus.BackColor = Color.Gainsboro;

					cmdAction.Text      = "EIN";
					cmdAction.Enabled   = true;
					
					cmdEnde.Text        = "Abbrechen";
					cmdEnde.Enabled     = true;
					
					mnuDatei.Enabled    = true;
					mnuExtras.Enabled   = true;

					pnlScript.Enabled   = false;
					pnlScript.BackColor = Color.Gray;
					pnlRun.Enabled      = false;
					pnlRun.BackColor    = Color.Gray;
					picDrive.Enabled    = false;
					picDrive.BackColor  = Color.Gray;
					break;
				case PrgModus.Home:
					lblStatus.Text      = "Home anfahren";
					lblStatus.BackColor = Color.Green;

					cmdAction.Text      = "HOME";
					cmdAction.Enabled   = true;
					
					cmdEnde.Text        = "ENDE";
					cmdEnde.Enabled     = true;
					
					mnuDatei.Enabled    = true;
					mnuExtras.Enabled   = false;

					pnlScript.Enabled   = false;
					pnlScript.BackColor = Color.Gray;
					pnlRun.Enabled      = false;
					pnlRun.BackColor    = Color.Gray;
					picDrive.Enabled    = false;
					picDrive.BackColor  = Color.Gray;
					break;
				case PrgModus.TeachIn:
					lblStatus.Text      = "TeachIn";
					lblStatus.BackColor = Color.Green;

					cmdAction.Text      = "HOME";
					cmdAction.Enabled   = true;
					
					cmdEnde.Text        = "ENDE";
					cmdEnde.Enabled     = true;
					
					mnuDatei.Enabled    = true;
					mnuExtras.Enabled   = false;
					
					pnlScript.Enabled   = true;
					pnlScript.BackColor = Color.Gainsboro;
					pnlRun.Enabled      = true;
					pnlRun.BackColor    = Color.Gainsboro;
					picDrive.Enabled    = true;
					picDrive.BackColor  = Color.Gainsboro;
					break;

				case PrgModus.Run:
					lblStatus.Text      = "RUN";
					lblStatus.BackColor = Color.GreenYellow;

					cmdAction.Text      = "HALT";
					cmdAction.Enabled   = true;
					
					cmdEnde.Text        = "ENDE";
					cmdEnde.Enabled     = true;
					
					mnuDatei.Enabled    = false;
					mnuExtras.Enabled   = false;
					
					pnlScript.Enabled   = false;
					pnlScript.BackColor = Color.Gray;
					pnlRun.Enabled      = true;
					pnlRun.BackColor    = Color.Gainsboro;
					picDrive.Enabled    = true;
					picDrive.BackColor  = Color.Gainsboro;
					break;
			}
			prgModus = newModus;
		}

		private void HomeRun() {  // --- Anfahren der Home-Position
			ft.NotHalt = false;
			ft.MoveHome();
			ft.ClearMotors();
			lblSaulePos.Text = "0";
			lblArmHPos.Text  = "0";
			lblArmVPos.Text  = "0";
			for(int i = 0; i < MoveWerte.Length; i++) MoveWerte[i] = 0;
		}

		private string MoveToScript() {  // --- bertragen der akt. Position 
			                             //     in einen String
			string Zeile;
			Zeile = ft.MotCntl[0].actPos.ToString("   000") +
				    ft.MotCntl[1].actPos.ToString("   000") +
				    ft.MotCntl[2].actPos.ToString("   000");
		    Zeile += ft.MotCntl[3].actPos == 0 ? "   000" : "   001";
			return Zeile;
		}

		private void ScriptToMove() {  // --- Extrahieren der (Soll)Position 
			                           //     aus einem String
			string Zeile = lstScript.Text;
			MoveWerte[0] = Convert.ToInt32(Zeile.Substring(0,  6));
			MoveWerte[1] = Convert.ToInt32(Zeile.Substring(6,  6));
			MoveWerte[2] = Convert.ToInt32(Zeile.Substring(12, 6));
			MoveWerte[3] = Convert.ToInt32(Zeile.Substring(18, 6));
		}

		private void DirtySpeichern() { // --- Speichern eines Scripts, wenn Dirty
			if(IsDirty) {
				if(MessageBox.Show("Soll das Script gespeichert werden ?", 
					Application.ProductName, 
					MessageBoxButtons.YesNo, 
					MessageBoxIcon.Question, 
					MessageBoxDefaultButton.Button2) == DialogResult.Yes) {
					if (ScriptName == " [Neu]") {
						saveScript.InitialDirectory = Application.StartupPath;
						if(saveScript.ShowDialog() == DialogResult.OK) { 
							Speichern(saveScript.FileName);
						}
					}
					else Speichern(ScriptName);
				}
			}
		}

		private void Zusatz(int OnOff) {  // --- Steuern Zusatzgert (Greifer, Lampe ...)
			MoveWerte[3] = OnOff;
			try {
				if (Modell.Typ == "Greifer") {
					if(OnOff == 0) 
						ft.MoveTo(ft.MotCntl[0].actPos, ft.MotCntl[1].actPos, 
							ft.MotCntl[2].actPos, 0);
					else ft.MoveTo(ft.MotCntl[0].actPos, ft.MotCntl[1].actPos, 
							 ft.MotCntl[2].actPos, ft.MotCntl[3].maxPos);
				}
				else {
					ft.SetMotor((int)Out.M4, OnOff);
					ft.Pause(500);
				}
			}
			catch(FishFaceException eft) {
				lblBetrieb.BackColor = Color.Red;
				lblStatus.Text       = eft.Message;
			}
		}

		private void Speichern(string FileName) {  // --- Speichern eines Scriptfiles
			StreamWriter sr = new StreamWriter(FileName);
			for(int i = 0; i < lstScript.Items.Count; i++) {
				lstScript.SelectedIndex = i;
				sr.WriteLine(lstScript.SelectedItem);
			}
			sr.Close();
			this.Text = Application.ProductName + " - " + 
				FileName.Substring(FileName.LastIndexOf(@"\")+1);
			IsDirty = false;
		}

		// --- Button-Routinen ---------------------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e) {
			// --- EIN : Herstellen der Interface-Verbindung
			//     HOME : Anfahren Home-Position
			//     HALT : Anhalten von Robot-Aktionen im PrgModus Run
			if(cmdAction.Text == "EIN") {
				try {
					ft = new FishRobot(new int[,] {{1, Modell.Saule}, 
                                                   {2, Modell.ArmH},
                                                   {3, Modell.ArmV},
                                                   {4, Modell.Greifer}});
					if (Interface.COM) 
						ft.OpenInterface((IFTypen)Interface.Typ, 
							             (int)Interface.pNr, 999, true);
					else 
					  ft.OpenInterface((IFTypen)Interface.Typ, Interface.Serial, true);

					ft.PositionChange  += new FishRobot.CommonDelegate(PositionsAnzeige);
					Interface.Firmware  = ft.ActDevice.Firmware;
					Interface.Serial    = ft.ActDevice.SerialNr;
					tmrI.Enabled        = true;
					ModellDaten();
					ModusWechsel(PrgModus.Home);
				   }
				catch (FishFaceException eft) {
					lblStatus.Text = eft.Message;
					lblStatus.BackColor = Color.Red;
					ft.CloseInterface();
				}
			}
			else if(cmdAction.Text == "HALT") {
				ft.NotHalt = true;
				chkRunRepeat.Checked = false;
			}
			else {
				try {
					ModusWechsel(PrgModus.Home);
					HomeRun();
					ModusWechsel(PrgModus.TeachIn);
				}
				catch(FishFaceException eft) {
					lblStatus.Text = eft.Message;
					lblStatus.BackColor = Color.Red;
				}
			}
		}

		private void cmdEnde_Click(object sender, System.EventArgs e) {
			// --- Beenden des Programms (wenn Enabled)
			//     Siehe auch ftmMain_Closed
			this.Close();
		}

		// --- Form-Routinen --------------------------------------------------

		private void frmMain_Load(object sender, System.EventArgs e) {
			// --- Laden bzw. Aufsetzen der persistenten Daten ------------
			prgModus = PrgModus.None;
			if(File.Exists(IniName)) {
				BinaryFormatter ser = new BinaryFormatter();
				FileStream bin      = new FileStream(IniName, FileMode.Open);
				pd                  = (PerDaten)ser.Deserialize(bin);
				bin.Close();
			}
			else pd = new PerDaten();

			this.Left      = pd.FormLeft;
			this.Top       = pd.FormTop;
			this.Text      = Application.ProductName;
			ScriptName     = " [Neu]";

			Modell         = pd[0];
			Interface      = pd.IntModelle[0];
			ModellDaten();   // --- Anzeige der Modelldaten vom letzten Lauf
			ModusWechsel(PrgModus.Ein);
		}

		private void frmMain_Closed(object sender, System.EventArgs e) {
			// --- Speichern der persistenten Daten -----------------
			pd.IntModelle[0]    = Interface;
			tmrI.Enabled        = false;
			BinaryFormatter ser = new BinaryFormatter();
			FileStream bin      = new FileStream(IniName, FileMode.Create);
			pd.FormLeft         = this.Left;
			pd.FormTop          = this.Top;
			ser.Serialize(bin, pd);
			bin.Close();

			DirtySpeichern();    // --- Speichern Scriptfile, wenn Dirty

			if(ft != null) ft.CloseInterface();  // --- Schlieen Interface-Verbindung
		}

		// --- Men-Routinen ----------------------------------------------

		private void mnuModell_Click(object sender, System.EventArgs e) {
			// --- Aufruf DialogForm mit Modelldaten -----------------
			//     Position : rechte, untere Ecke von frmMain
			frmModell m = new frmModell(pd);
			m.Left = this.Left + this.Width  - m.Width  - 20;
			m.Top  = this.Top  + this.Height - m.Height - 20;
			m.ShowDialog();
			Modell = pd[0];    // --- bernahme der Modelldaten
			ModellDaten();     // --- Anzeige der neuen Modelldaten
		}

		private void mnuAbout_Click(object sender, System.EventArgs e) {
			// --- Anzeige der About-Box ----------------------------
			frmAbout a = new frmAbout();
			a.Left = this.Left + this.Width  - a.Width  - 20;
			a.Top  = this.Top  + this.Height - a.Height - 20;
			a.ShowDialog();
		}

		private void mnuInterface_Click(object sender, System.EventArgs e) {
			// --- Aufruf DialogForm mit Interfacedaten -----------------
			frmSchnitt s = new frmSchnitt(pd);
			s.Left = this.Left + this.Width  - s.Width  - 20;
			s.Top  = this.Top  + this.Height - s.Height - 20;
			s.ShowDialog();
			Interface = pd.IntModelle[0];  // --- bernahme der Interfacedaten
			ModellDaten();                 // --- Anzeige der neuen Interfacedaten
		}

		private void mnuNeu_Click(object sender, System.EventArgs e) {
			// --- Starten eines neuen Scriptfiles -----------------
			lstScript.Items.Clear();
			ScriptName = " [Neu]";
			this.Text  = Application.ProductName + ScriptName;
			for(int i = 0; i < MoveWerte.Length; i++) MoveWerte[i] = 0;
			lstScript.Items.Add("     0     0     0     0");
			lstScript.SelectedIndex = 0;
			IsDirty = false;

		}

		private void mnuOffnen_Click(object sender, System.EventArgs e) {
			// --- ffnen eines vorhandenen Scriptfiles ---------------
			string Zeile;
			DirtySpeichern();         // --- bedingtes Speichern eines geladenen Scripts
			openScript.InitialDirectory = Application.StartupPath;
			if(openScript.ShowDialog() == DialogResult.OK) {
				ScriptName = openScript.FileName;   // --- Standard Open-Dialog
				StreamReader sr = new StreamReader(ScriptName);
				Zeile = sr.ReadLine();              // --- Lesen Textfile
				lstScript.Items.Clear();            //     und Abstellen in ListBox
				while(Zeile != null) {
					lstScript.Items.Add(Zeile);
					Zeile = sr.ReadLine();
				}
				sr.Close();
				lstScript.SelectedIndex = 0;
				this.Text = Application.ProductName + " - " + 
									ScriptName.Substring(ScriptName.LastIndexOf(@"\")+1);
				IsDirty = false;
			}
		}

		private void mnuSpeichern_Click(object sender, System.EventArgs e) {
			// --- Unbedingts Speichern des aktuellen Scriptfiles
			//     Wenn noch nicht benannt, wird nachgefragt
			if (ScriptName == " [Neu]") {
				saveScript.InitialDirectory = Application.StartupPath;
				if(saveScript.ShowDialog() == DialogResult.OK) {
					ScriptName = saveScript.FileName;
					Speichern(ScriptName);
				}
			}
			else Speichern(ScriptName);
		}

		private void mnuSpeichernU_Click(object sender, System.EventArgs e) {
			// --- Unbedingtes Speichern des aktuellen Scriptfiles
			//     Der Filename wird erfragt
			saveScript.InitialDirectory = Application.StartupPath;
			if(saveScript.ShowDialog() == DialogResult.OK) {
				ScriptName = saveScript.FileName;
				Speichern(ScriptName);
			}
		}

		private void mnuBeenden_Click(object sender, System.EventArgs e) {
			// --- Beenden des Programms, wenn Enabled ----------------
			//     Siehe auch frmMain_Closed
			this.Close();
		}

		// --- picDrive-Routinen -----------------------------------------------

		private void lblRobMouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			// --- Fahren einer Robot-Komponent solange MouseDown
			//     Die Richtung wird ber den Tag des entsprechenden Label mitgegeben
			if(ft == null) return;
			Label l = (Label)sender;
			ft.NotHalt = false;
			try {
				switch(Convert.ToInt32(l.Tag)){
					case 1:            // --- Sule zum Endtaster
						ft.MoveTo(0, ft.MotCntl[1].actPos, ft.MotCntl[2].actPos);
						break;
					case 2:            // --- Sule weg vom Endtaster
						ft.MoveTo(ft.MotCntl[0].maxPos, 
							      ft.MotCntl[1].actPos, ft.MotCntl[2].actPos);
						break;
					case 3:           // --- Arm, horizontal, zurck
						ft.MoveTo(ft.MotCntl[0].actPos, 0, ft.MotCntl[2].actPos);
						break;
					case 4:           // --- Arm, horizontal, vor
						ft.MoveTo(ft.MotCntl[0].actPos, ft.MotCntl[1].maxPos, 
							      ft.MotCntl[2].actPos);
						break;
					case 5:          // --- Arm, vertikal, auf
						ft.MoveTo(ft.MotCntl[0].actPos, ft.MotCntl[1].actPos, 0);
						break;
					case 6:          // --- Arm, vertikal, ab
						ft.MoveTo(ft.MotCntl[0].actPos, ft.MotCntl[1].actPos, 
							ft.MotCntl[2].maxPos);
						break;
				}
			}
			catch(FishFaceException eft) {
				lblBetrieb.BackColor = Color.Red;
				lblStatus.Text       = eft.Message;
			}
		}

		private void lblRobMouseUp(object sender, System.Windows.Forms.MouseEventArgs e) {
			if(ft != null) ft.NotHalt = true;
		}

		private void lblGreiferClick(object sender, System.EventArgs e) {
			if(ft == null) return;
			ModusWechsel(PrgModus.Run);
			ft.NotHalt = false;
			Label l = (Label)sender;

			int OnOff = Convert.ToInt32(l.Tag);
			if(OnOff == 7) OnOff = 1; else OnOff = 0;
			Zusatz(OnOff);
			ModusWechsel(PrgModus.TeachIn);
		}

		// --- Timer-Routinen --------------------------------------------
		
		private void tmrI_Tick(object sender, System.EventArgs e) {
			// --- berwachen Interface-Zustand -----------------
			try{
				int res = ft.Outputs;
				lblBetrieb.BackColor = Color.Green;
			}
			catch(FishFaceException eft) {
				lblBetrieb.BackColor = Color.Red;
				lblStatus.Text       = eft.Message;
			}
		}

		private void PositionsAnzeige(object sender, int[] actPos) {
			// --- Anzeige der aktuellen Robot-Position und der Verfahraktivitten
			try {
				int EW = ft.Outputs;

				lblSaulePos.Text = actPos[0].ToString();
				if((EW & 0x3) > 0) lblSaule.BackColor = Color.GreenYellow;
				else lblSaule.BackColor = Color.Gray;

				lblArmHPos.Text  = actPos[1].ToString();
				if((EW & 0xC) > 0) lblArmH.BackColor = Color.GreenYellow;
				else lblArmH.BackColor = Color.Gray;
			
				lblArmVPos.Text  = actPos[2].ToString();
				if((EW & 0x30) > 0) lblArmV.BackColor = Color.GreenYellow;
				else lblArmV.BackColor = Color.Gray;

				if((EW & 0xC0) > 0) lblGreifer.BackColor = Color.GreenYellow;
				else lblGreifer.BackColor = Color.Gray;
			}
			catch(FishFaceException eft) {
				lblBetrieb.BackColor = Color.Red;
				lblStatus.Text       = eft.Message;
			}
		}

		// --- pnlScript-Routinen ------------------------------------------

		private void cmdPosSpeichern_Click(object sender, System.EventArgs e) {
			// --- Speichern der akt. Position in die ausgewhlte Scriptzeile
			if(lstScript.Items.Count < 1) return;
			int i = lstScript.SelectedIndex;
			lstScript.Items.RemoveAt(i);
			lstScript.Items.Insert(i, MoveToScript());
			IsDirty = true;
		}

		private void cmdPosEinfugen_Click(object sender, System.EventArgs e) {
			// --- Einfgen der akt. Position vor die ausgewhlte Scriptzeile
			if(lstScript.SelectedIndex < 0) return;
			int i = lstScript.SelectedIndex;
			lstScript.Items.Insert(i, MoveToScript());
			lstScript.SelectedIndex = i;
			IsDirty = true;		
		}

		private void cmbPosAnfugen_Click(object sender, System.EventArgs e) {
			// --- Anfgen der akt. Position hinter die letzte Scriptzeile
			lstScript.Items.Add(MoveToScript());
			lstScript.SelectedIndex = lstScript.Items.Count - 1;
			IsDirty = true;
		}

		private void cmdPosLoschen_Click(object sender, System.EventArgs e) {
			// --- Lschen der ausgewhlten Scriptzeile -------------------
			if(lstScript.Items.Count < 1) return;
			int i = lstScript.SelectedIndex;
			lstScript.Items.RemoveAt(i);
			lstScript.SelectedIndex = i;
			IsDirty = true;		
		}

		// --- pnlRun-Routinen ------------------------------------------

		private void cmdRunStart_Click(object sender, System.EventArgs e) {
			// --- Starten des Abfahrens des vollstndigen Scripts
			//     Bei chkRunRepeat endlos
			if(lstScript.Items.Count < 1) return;
			ModusWechsel(PrgModus.Run);
			do {
				lstScript.SelectedIndex = -1;
				ft.NotHalt = false;
				do {
					lstScript.SelectedIndex++;
					ScriptToMove();  // --- bernehmen der jeweiligen Position nach MoveWerte
					ft.MoveTo(MoveWerte[0], MoveWerte[1], MoveWerte[2]);
					Zusatz(MoveWerte[3]);
				} while((lstScript.SelectedIndex < lstScript.Items.Count-1) && !ft.NotHalt);
			} while(chkRunRepeat.Checked);
			ModusWechsel(PrgModus.TeachIn);
		}

		private void cmdRunClick(object sender, System.EventArgs e) {
			// --- Anfahren einer einzelnen Position -------------
			if(lstScript.Items.Count < 1) return;
			Button c = (Button)sender;
			switch(Convert.ToInt32(c.Tag)){
				case 1:  // --- Position vor der markierten
					if(lstScript.SelectedIndex > 0) lstScript.SelectedIndex--;
					break;
				case 2:  // --- Position nach der markierten
					if(lstScript.SelectedIndex < lstScript.Items.Count-1)
						lstScript.SelectedIndex++;
					break;
				case 3:  // --- Markierte Position
					break;
			}
			ModusWechsel(PrgModus.Run);
			ScriptToMove();        // --- bernehmen der Position nach MoveWerte
			ft.NotHalt = false;
			ft.MoveTo(MoveWerte[0], MoveWerte[1], MoveWerte[2]);
			Zusatz(MoveWerte[3]);
			ModusWechsel(PrgModus.TeachIn);
		}
	}
}
